//////////////////////////////////////////////////////////////////////
// click.js
//  CHANGELOG
//  2010.05.07 clickNODE()
//////////////////////////////////////////////////////////////////////

clickNODE

function clickINPUTS(top, left)
{
	var	old_pos		= $("#TEXT_NODE").position();
	var	old_top		= old_pos.top;
	var	old_left	= old_pos.left;

	fadeInTOOLBAR("", 0, 0);
	// 2010/07/19 全ての場合に呼ばれるのでここに移動
	hideSUBS();

	if( g_mmode == "NODE" ){
		if( $("#TEXT_NODE").val() != "" ){
			// 2010/02/17 ノード入力後、別のエリアをクリックした場合			// 2013/08/04 ノードが座標(0, 0)ではなく、元の位置に配置するため
			dispELEMENT("TEXT_NODE", old_top, old_left);
			insertNODE(true);
			dispOUTPUTS();
			dispELEMENT("TEXT_NODE", root_top + top, root_left + left);
			$("#TEXT_NODE").val("").focus();
			// メッセージは insertNODE() で表示済み
		}
		else{
			dispELEMENT("TEXT_NODE", root_top + top, root_left + left);
			$("#TEXT_NODE").val("").focus();
			dispMESSAGE("ノード名を入力して Enter を押してください",
				"#f8e58c");
		}
	}
	else if( g_mmode == "LINE" ){
		// 2010/07/19 LINE描画モードでクリックすると初期モードに遷移
		clickMENUBAR(g_mmode);
		hideELEMENT("MESSAGE");
	}
	else if( g_mmode == "CUT" ){
		// 2010/07/31 mousedown->mousemove->mouseup
	}
	else if( g_mmode != "" ){
		var		no	= insertCONSTR(g_mmode, root_top + top, root_left + left);

		clearMENU(g_mmode);
		downMENU("LINE");
		clickCONSTR(no);
	}

	return true;
}

function clickINPUT_LIST(menu)
{
	var		no		= 0;
	var		pos		= null;
	var		height	= 0;

	fadeInTOOLBAR("", 0, 0);
	hideELEMENT("TEXT_NODE");
	hideELEMENT("INPUT_NODE_LIST");
	hideELEMENT("INPUT_OP_LIST");

	if( menu == "TEXT_UPDATE" ){
		no = $("#INPUT_NODE_LIST").attr("no");
		pos		= $("#N" + no).position();
		height	= $("#N" + no).height();
		dispTEXT_UPDATE(no, pos.top + height, pos.left);
	}
	else if( menu == "AND_UPDATE" ){
		no = $("#INPUT_NODE_LIST").attr("no");
		opNODE(no, "AND");
		clearGRAPH();
		sortGRAPH();	// 2010/07/19 並べ替え
		dispGRAPH();
		dispOUTPUTS();
	}
	else if( menu == "OR_UPDATE" ){
		no = $("#INPUT_NODE_LIST").attr("no");
		opNODE(no, "OR");
		clearGRAPH();
		sortGRAPH();	// 2010/07/19 並べ替え
		dispGRAPH();
		dispOUTPUTS();
	}
	else if( menu == "OP_DELETE" ){
		no = $("#INPUT_NODE_LIST").attr("no");
		opNODE(no, "");
		clearGRAPH();
		sortGRAPH();	// 2010/07/19 並べ替え
		dispGRAPH();
		dispOUTPUTS();
	}
	else if( menu == "NODE_DELETE" ){
		no = $("#INPUT_NODE_LIST").attr("no");
		deleteNODE(no);
	}
	else if( menu == "AND_SET" ){
		no = $("#INPUT_OP_LIST").attr("no");
		opNODE(no, "AND");
		clearGRAPH();
		sortGRAPH();	// 2010/07/19 並べ替え
		dispGRAPH();
		dispOUTPUTS();
	}
	else if( menu == "OR_SET" ){
		no = $("#INPUT_OP_LIST").attr("no");
		opNODE(no, "OR");
		clearGRAPH();
		sortGRAPH();	// 2010/07/19 並べ替え
		dispGRAPH();
		dispOUTPUTS();
	}

	return true;
}

function clickTOOL_LIST(menu)
{
	var		no		= 0;
	var		pos		= null;
	var		height	= 0;

	fadeInTOOLBAR("", 0, 0);
	hideSUBS();

	if( menu == "CLEAR" ){
		if( g_confirm_before_clear == true ){
			hideSUBS();
			$("#NO_CONFIRM_BEFORE_CLEAR")
				.attr("checked", !(g_confirm_before_clear));
			dispELEMENT("CLEAR_CONFIRM", 300, 300);
		}
		else{
			clearALL();
		}
	}
	else if( menu == "EXPORT" ){
		pos = $("#INPUTS").position();
		$("#EXPORT_CSV_GRAPH").text(getEXPORT_CSV_GRAPH());
		$("#EXPORT_CSV_TABLE").text(getEXPORT_CSV_TABLE());
		$("#EXPORT_CSV_COVERAGE").text(getEXPORT_CSV_COVERAGE());
		dispELEMENT("EXPORTS", pos.top, pos.left);
	}
	else if( menu == "IMPORT_CSV" ){
		pos = $("#INPUTS").position();
		$("#IMPORT_CSV_GRAPH").val("");
		dispELEMENT("IMPORTS_CSV", pos.top, pos.left);
		$("#IMPORT_CSV_GRAPH").focus();
	}
	else if( menu == "ADJUST_GRAPH" ){
		$("#IMPORT_CSV_GRAPH").val(getEXPORT_CSV_GRAPH());
		adjustGraph("グラフ表示の調整を行いました。");
	}
	else if( menu == "CONFIGS" ){
		pos = $("#INPUTS").position();
		getCONFIGS();
		dispELEMENT("CONFIGS", pos.top, pos.left);
	}
	else if( menu == "SHOW_OPERATION" ){
		dispOPERATION();
	}
	else if( menu == "SHOW_CALC" ){
		dispCALC();
	}
	else if( menu == "SHOW_TABLE" ){
		var		pos	= $("#INPUTS").position();
		if( tests.length > 0 ){
			dispELEMENT("TABLE", pos.top, pos.left);
		}
	}
	else if( menu == "SHOW_COVERAGE" ){
		var		pos	= $("#INPUTS").position();
		if( tests.length > 0 ){
			dispELEMENT("COVERAGE", pos.top, pos.left);
		}
	}
	else if( menu == "SHOW_COVERAGE" ){
		var		pos	= $("#INPUTS").position();
		if( tests.length > 0 ){
			dispELEMENT("COVERAGE", pos.top, pos.left);
		}
	}
	else if( menu == "SHOW_GRAPH_IMAGE" ){
// 2010/02/13 画像化
		var		pos	= $("#INPUTS").position();

		imageGRAPH(pos.top, pos.left);
		try {
			var img_png_src = canvas.toDataURL();
			
			window.open(img_png_src, "CEG", "width=1000,height=600");
		} catch(e) {
			dispMESSAGE("原因結果グラフの画像化に未対応です。", "#f8e58c");
		}
		adjustGraph("原因結果グラフをPNG画像出力しました");
	}
	else if( menu == "UNDO" ){
		alert("未実装");
	}
	else if( menu == "SHOW_HELP" ){
		pos = $("#INPUTS").position();
		if( g_mmode == "" ){
			$("#MANUAL_INNER").attr("src", "gui.html");
		}
		else if( g_mmode == "NODE" ){
			$("#MANUAL_INNER").attr("src", "node.html");
		}
		else if( g_mmode == "ONE" || g_mmode == "EXCL" || g_mmode == "INCL" || g_mmode == "REQ" || g_mmode == "MASK" ){
			$("#MANUAL_INNER").attr("src", "constr.html");
		}
		dispELEMENT("MANUALS", pos.top, pos.left);
	}
	else if( menu == "SHOW_DOWNLOAD" ){
		window.open("http://softest.jp/zip/CEGTest-1.6-20130804.zip", "download");
	}
	else if( menu == "SHOW_QUERY" ){
		pos = $("#INPUTS").position();
		dispELEMENT("QUERY", pos.top, pos.left);
	}
	return true;
}

function clickMENUBAR(idname)
{

	if( g_mmode == idname ){
		// 初期モードに戻る
		g_mmode = "";
		$("#" + idname).attr("src", "images/" + idname + ".png");
		$(".NODE,.CONSTR")
		.draggable("enable");
		hideELEMENT("MESSAGE");

		hideSUBS();
	}
	else{
		// click前のモードがあれば初期モードに変更
		if( g_mmode != "" ){
			$("#" + g_mmode).attr("src", "images/" + g_mmode + ".png");
		}
		// idnameのモードに変更
		g_mmode = idname;
		$("#" + idname).attr("src", "images/" + idname + "down.png");
		$(".NODE,.CONSTR")
		.draggable("disable");
		hideSUBS();
		dispMESSAGE("", "#f8e58c");
	}
	return true;
}

function clickNODE(no)
{
	var		pos	= $("#N" + no).position();
	var		height	= $("#N" + no).height();

	if( g_mmode == "LINE" ){
		if( g_line_left == -1 ){
			hideSUBS();
			g_line_left = no;
			$("#LINE_LEFT").css("color", "#000000").text("原因");
			dispELEMENT("LINE_LEFT", pos.top + height + 5, pos.left);
			logmsg += "LINE " + nodes[no].getText() + " =>\n";
			dispMESSAGE("始点=" + nodes[no].getText(), "#f8e58c");
		}
		else if( g_line_left == no && g_line_constr == false ){
			if( g_line_not == 0 ){
				g_line_not = 1;
				$("#LINE_LEFT").css("color", "#ffa500").text("原因 NOT");
				logmsg += "LINE NOT " + nodes[no].getText() + " =>\n";
				dispMESSAGE("始点=NOT " + nodes[no].getText(), "#f8e58c");
			}
			else{
				clearLINE();
				logmsg += "LINE CLEAR\n";
				dispMESSAGE("始点=", "#f8e58c");
			}
		}
		else if( g_line_constr == false ){
			// NODE --> NODE(this)
			g_line_right = no;
			nodes[g_line_right].addSeq(g_line_left, 1, g_line_not);

			if( g_line_not == 1 ){
				logmsg += "LINE " + nodes[g_line_left].getText() + " => NOT " + nodes[no].getText() + "\n";
			}
			else{
				logmsg += "LINE " + nodes[g_line_left].getText() + " => " + nodes[no].getText() + "\n";
			}
			hideSUBS();
			sortGRAPH();	// 2010/07/19 並べ替え
			dispGRAPH();

			// AND/ORが未設定の場合
			if( nodes[no].getOp() == "" ){
				var		content	= "";
				var		menu	= "";
				var		shadow	= "";
				var		mStyle	= {
							listStyle: 'none',
							padding: '1px',
							margin: '0px',
							backgroundColor: '#fff',
							border: '1px solid #999',
							width: '150px'
							};
				var		iStyle	= {
							margin: '0px',
							color: '#000',
							display: 'block',
							cursor: 'default',
							padding: '3px',
							border: '1px solid #fff',
							backgroundColor: 'transparent'
							};
				var		hStyle	= {
							border: '1px solid #0a246a',
							backgroundColor: '#b6bdd2'
							};

				content = $("#INPUT_OP_LIST")
					.find('ul:first')
					.clone(true);
				content.css(mStyle)
				.find('li').css(iStyle)
				.hover(
					function() {
					$(this).css(hStyle);
					},
					function(){
					$(this).css(iStyle);
					}
				)
				.click(
					function() {
						menu.hide();
						shadow.hide();
						if( $(this).attr("id") == "AND_UPDATE" ){
							opNODE(no, "AND");
							clearGRAPH();
							sortGRAPH();
							dispGRAPH();
							dispOUTPUTS();
						}
						else if( $(this).attr("id") == "OR_UPDATE" ){
							opNODE(no, "OR");
							clearGRAPH();
							sortGRAPH();
							dispGRAPH();
							dispOUTPUTS();
						}
					}
				)
				.find('img').css({verticalAlign:'middle',paddingRight:'2px'});

				menu = $('<div id="jqContextMenu"></div>')
						.css({position:'absolute', zIndex:'500', left: pos.left, top: pos.top + height})
						.appendTo('body')
						.bind('click', function(e) {
							e.stopPropagation();
						})
						.show();
				menu.html(content);
				shadow = $('<div></div>')
						.css({backgroundColor:'#000',position:'absolute',opacity:0.2,zIndex:499})
						.appendTo('body')
						.css({width:menu.width(),height:menu.height(),left:pos.left+2,top:pos.top+height+2})
						.show();
				dispMESSAGE("論理関係[∧][∨]を設定してください", "#f8e58c");

			}
			else{
				dispOUTPUTS();
				dispMESSAGE(nodes[no].getText() + "の論理関係を設定しました",
					"#f8e58c");
			}
		}
		else{
			// CONSTR --> NODE(this)
			g_line_right = no;
			if( constrs[g_line_left].isStart() == true ){
				constrs[g_line_left].addSeqStart(g_line_right, 1, g_line_not);
				if( g_line_not == 1 ){
					logmsg += "LINE NOT " + nodes[no].getText() + " => " + constrs[g_line_left].getType() + "\n";
				}
				else{
					logmsg += "LINE " + nodes[no].getText() + " => " + constrs[g_line_left].getType() + "\n";
				}
			}
			else{
				constrs[g_line_left].addSeqEnd(g_line_right, 1, g_line_not);					if( g_line_not == 1 ){
					logmsg += "LINE " + constrs[g_line_left].getType() + " => NOT " + nodes[no].getText() + "\n";
				}
				else{
					logmsg += "LINE " + constrs[g_line_left].getType() + " => " + nodes[no].getText() + "\n";
				}
			}
			dispMESSAGE("制約 " + constrs[g_line_left].getType() + " の対象ノードとして " + nodes[no].getText() + " を設定しました", "#f8e58c");

			hideSUBS();
			clearGRAPH();	// 2010/06/28 表示不具合のため
			dispGRAPH();
			dispOUTPUTS();
		}
	}
	return true;
}

function clickCONSTR(no)
{
	var		pos	= $("#C" + no).position();
	var		height	= $("#C" + no).height();
	var		type	= constrs[no].getType();

	if( g_mmode == "LINE" ){
		if( g_line_left == -1 ){
			hideSUBS();
			g_line_left = no;
			g_line_constr = true;
			$("#LINE_LEFT").css("color", "#000000").text("節点");
			dispELEMENT("LINE_LEFT", pos.top + height + 7, pos.left);
			logmsg += "LINE " + constrs[no].getType() + " =>\n";
			if( type == "ONE" || type == "EXCL" || type == "INCL" ){
				dispMESSAGE(type + " の対象ノードをクリックしてください",
					"#f8e58c");
			}
			else{
				if( constrs[no].isStart() == true ){
					dispMESSAGE(type + " の一つ目の対象ノードをクリックしてください", "#f8e58c");
				}
				else{
					dispMESSAGE(type + " の二つ目以降の対象ノードをクリックしてください", "#f8e58c");
				}
			}
		}
		else if( g_line_left == no && g_line_constr == true ){
			if( g_line_not == 0 ){
				g_line_not = 1;
				$("#LINE_LEFT").css("color", "#ffa500").text("節点 NOT");
				logmsg += "LINE NOT " + constrs[no].getType() + " =>\n";
			}
			else{
				logmsg += "LINE " + constrs[no].getType() + " CLEAR\n";
				clearLINE();
				dispMESSAGE("", "#f8e58c");
			}
		}
	}
	return true;
}
