//////////////////////////////////////////////////////////////////////
// CONSTR
// CHANGELOG
//////////////////////////////////////////////////////////////////////

function CONSTR(type)
{
	this.type		= type;				// ONE,EXCL,INCL,REQ,MASK
	this.seq		= "";				// 制約関係
	this.top		= 0;				// 表示位置
	this.left		= 0;				// 表示位置
	this.width		= 0;				// 表示幅
	this.height		= 0;				// 表示高
	this.memo		= "";				// メモ
	this.zoom		= -1;				// ズーム番号

	// GET
	this.getType		= function()
	{
		return this.type;
	}

	this.getSeq			= function()
	{
		return this.seq;
	}

	this.getTop			= function()
	{
		return this.top;
	}

	this.getLeft			= function()
	{
		return this.left;
	}

	this.getWidth			= function()
	{
		return this.width;
	}

	this.getHeight			= function()
	{
		return this.height;
	}

	this.getMemo			= function()
	{
		return this.memo;
	}

	this.getZoom			= function()
	{
		return this.zoom;
	}

	// SET
	this.setType			= function(type)
	{
		this.type		= type;
		return true;
	}

	this.setSeq				= function(seq)
	{
		this.seq		= seq;
		return true;
	}

	this.setTop				= function(top)
	{
		this.top		= top;
		return true;
	}

	this.setLeft				= function(left)
	{
		this.left		= left;
		return true;
	}

	this.setWidth				= function(width)
	{
		this.width		= width;
		return true;
	}

	this.setHeight				= function(height)
	{
		this.height		= height;
		return true;
	}

	this.setMemo				= function(memo)
	{
		this.memo		= memo;
		return true;
	}

	this.setZoom				= function(zoom)
	{
		this.zoom		= zoom;
		return true;
	}

	// UTIL
	this.exprSeq		= function()
	{
		var		i;
		var		count = 0;
		var		len	= nodes.length;
		var		r	= this.seq.split(",");
		var		txt	= "";

		count = 0;
		if( this.type == "ONE" || this.type == "EXCL" || this.type == "INCL" ){
			txt += this.type + "(";
			for(i = 0; i < len; i++){
				if( r[i + 2*len] != 1 ){
					continue;
				}
				if( r[i + 3*len] == 1 ){
					if( count > 0 ){
						txt += " ";
					}
					txt += "NOT " + nodes[i].getText();
					count++;
				}
				else{
					if( count > 0 ){
						txt += " ";
					}
					txt += nodes[i].getText();
					count++;
				}
			}
			txt += ")";
		}
		else if( this.type == "REQ" || this.type == "MASK" ){
			txt += this.type + "=(";
			for(i = 0; i < len; i++){
				if( r[i] != 1 ){
					continue;
				}
				if( r[i + len] == 1 ){
					if( count > 0 ){
						txt += " ";
					}
					txt += "NOT " + nodes[i].getText();
					count++;
					break;
				}
				else{
					if( count > 0 ){
						txt += " ";
					}
					txt += nodes[i].getText();
					count++;
					break;
				}
			}
			for(i = 0; i < len; i++){
				if( r[i + 2*len] != 1 ){
					continue;
				}
				if( r[i + 3*len] == 1 ){
					if( count > 0 ){
						txt += " ";
					}
					txt += "NOT " + nodes[i].getText();
					count++;
				}
				else{
					if( count > 0 ){
						txt += " ";
					}
					txt += nodes[i].getText();
					count++;
				}
			}
			txt += ")";
		}

		return txt;
	}

	this.deduceLogic	= function(src)
	{
		var		i		= 0;
		var		total	= 0;
		var		on		= 0;
		var		len		= nodes.length;
		var		v		= (this.seq).split(",");
		var		isDeduce	= false;

		if( this.type == "ONE" ){
			var		nodata	= 0;
			var		ondata	= 0;

			for(i = 0; i < len; i++){
				if( v[2*len + i] == 1 ){
					if( v[3*len + i] == 1 ){
						// NOT
						if( src[i] == "F" || src[i] == "f" ){
							ondata = 1;
							break;
						}
						else if( src[i] == "" ){
							nodata++;
						}
					}
					else{
						if( src[i] == "T" || src[i] == "t" ){
							ondata = 1;
							break;
						}
						else if( src[i] == "" ){
							nodata++;
						}
					}
				}
			}

			if( ondata == 1 ){
				// その他はoff
				for(i = 0; i < len; i++){
					if( v[2*len + i] == 1 ){
						if( src[i] == "" ){
							if( v[3*len + i] == 1 ){
								// NOT
calcmsg += "  ONE " + nodes[i].getText() + "=[T]\n";
								src[i] = "T";
							}
							else{
calcmsg += "  ONE " + nodes[i].getText() + "=[F]\n";
								src[i] = "F";
							}
						}
					}
				}
			}
			if( nodata == 1 ){
				// 最後の1か所がon
				for(i = 0; i < len; i++){
					if( v[2*len + i] == 1 ){
						if( src[i] == "" ){
							if( v[3*len + i] == 1 ){
								// NOT
calcmsg += "##### ONE " + nodes[i].getText() + "=[F]\n";
								src[i] = "F";
								break;
							}
							else{
calcmsg += "##### ONE " + nodes[i].getText() + "=[T]\n";
								src[i] = "T";
								break;
							}
						}
					}
				}
			}
		}
		else if( this.type == "EXCL" ){
			var		nodata	= 0;
			var		ondata	= 0;

			for(i = 0; i < len; i++){
				if( v[2*len + i] == 1 ){
					if( v[3*len + i] == 1 ){
						// NOT
						if( src[i] == "F" || src[i] == "f" ){
							ondata = 1;
							break;
						}
						else if( src[i] == "" ){
							nodata++;
						}
					}
					else{
						if( src[i] == "T" || src[i] == "t" ){
							ondata = 1;
							break;
						}
						else if( src[i] == "" ){
							nodata++;
						}
					}
				}
			}

			if( ondata == 1 ){
				// その他はoff
				for(i = 0; i < len; i++){
					if( v[2*len + i] == 1 ){
						if( src[i] == "" ){
							if( v[3*len + i] == 1 ){
								// NOT
calcmsg += "##### EXCL " + nodes[i].getText() + "=[T]\n";
								src[i] = "T";
							}
							else{
calcmsg += "##### EXCL " + nodes[i].getText() + "=[F]\n";
								src[i] = "F";
							}
						}
					}
				}
			}
		}
		else if( this.type == "INCL" ){
			var		nodata	= 0;
			var		ondata	= 0;

			for(i = 0; i < len; i++){
				if( v[2*len + i] == 1 ){
					if( v[3*len + i] == 1 ){
						// NOT
						if( src[i] == "F" || src[i] == "f" ){
							ondata++;
						}
						else if( src[i] == "" ){
							nodata++;
						}
					}
					else{
						if( src[i] == "T" || src[i] == "t" ){
							ondata++;
						}
						else if( src[i] == "" ){
							nodata++;
						}
					}
				}
			}

			if( ondata == 0 && nodata == (len - 1) ){
				// 残り一つを残して全て off
				for(i = 0; i < len; i++){
					if( v[2*len + i] == 1 ){
						if( src[i] == "" ){
							if( v[3*len + i] == 1 ){
								// NOT
calcmsg += "##### INCL " + nodes[i].getText() + "=[T]\n";
								src[i] = "T";
							}
							else{
calcmsg += "##### INCL " + nodes[i].getText() + "=[F]\n";
								src[i] = "F";
							}
						}
					}
				}
			}
		}
		else if( this.type == "REQ" ){
			for(i = 0; i < len; i++){
				if( v[i] == 1 ){
					if( v[len + i] == 1 ){
						// NOT
						if( src[i] == "F" || src[i] == "f" ){
							isDeduce = true;
						}
					}
					else{
						if( src[i] == "T" || src[i] == "t" ){
							isDeduce = true;
						}
					}

					break;
				}
			}

			if( isDeduce == true ){
				for(i = 0; i < len; i++){
					if( v[i + 2*len] != 1 ){
						continue;
					}
					if( src[i] != "" ){
						continue;
					}

					if( v[i + 3*len] == 1 ){
						// NOT
calcmsg += "##### REQ " + nodes[i].getText() + "=[F]\n";
						src[i] = "F";
					}
					else{
calcmsg += "##### REQ " + nodes[i].getText() + "=[T]\n";
						src[i] = "T";
					}
				}
			}
		}

		return true;
	}

	this.maskLogic		= function(src)
	{
		var		i		= 0;
		var		len		= nodes.length;
		var		v		= (this.seq).split(",");
		var		isDeduce	= false;

		if( this.type == "MASK" ){
			for(i = 0; i < len; i++){
				if( v[i] == 1 ){
					if( v[len + i] == 1 ){
						// NOT
						if( src[i] == "F" || src[i] == "f" ){
							isDeduce = true;
						}
					}
					else{
						if( src[i] == "T" || src[i] == "t" ){
							isDeduce = true;
						}
					}

					break;
				}
			}

			if( isDeduce == true ){
				for(i = 0; i < len; i++){
					if( v[i + 2*len] != 1 ){
						continue;
					}

// 2011/02/12 MASK制約による既設定真理値の不一致
					if( src[i] != "" && src[i] != "M" ){
calcmsg += "##### MASK 不一致 " + nodes[i].getText() + "\n";
						return false;
					}
calcmsg += "##### MASK " + nodes[i].getText() + "=[M]\n";
					src[i] = "M";

// 2011/02/12 "M" を決定したことで論理式に矛盾が生じていないか確認
				}
			}
		}

		return true;
	}

	this.isStart			= function()
	{
		var		i;
		var		len		= nodes.length;
		var		r		= this.seq.split(",");

		if( this.type == "ONE" || this.type == "EXCL" || this.type == "INCL" ){
			return false;
		}
		for(i = 0; i < len; i++){
			if( r[i] == 1 ){
				return false;
			}
		}
		return true;
	}

	this.checkConstr		= function(src)
	{
		var		i	= 0;
		var		count	= 0;
		var		blank	= 0;
		var		mask	= 0;
		var		start	= -1;
		var		v	= (this.getSeq()).split(",");
		var		len	= nodes.length;

		if( this.type == "ONE" || this.type == "EXCL" || this.type == "INCL" ){
			for(i = 0; i < len; i++){
				if( v[2*len + i] != 1 ){
					continue;
				}

				if( v[3*len + i] == 1 ){
					// NOT
					switch(src[i]){
					case 'F': case 'f':
						count++;
						break;
					case 'T': case 't':
						break;
					case 'M':
						mask++;
						break;
					default:
						blank++;
						break;
					}
				}
				else{
					switch(src[i]){
					case 'T': case 't':
						count++;
						break;
					case 'F': case 'f':
						break;
					case 'M':
						mask++;
						break;
					default:
						blank++;
						break;
					}
				}
			}

			// check
			if( this.type == "ONE"
				&& mask == 0
				&& ( ( count == 0 && blank == 0 ) || count > 1 ) ){
calcmsg += "  " + this.exprSeq() + "\n";
				return this.exprSeq();
			}
			else if( this.type == "EXCL"
				&& mask == 0
				&& count > 1 ){
calcmsg += "  " + this.exprSeq() + "\n";
				return this.exprSeq();
			}
			else if( this.type == "INCL"
				&& mask == 0
				&& count == 0 && blank == 0 ){
calcmsg += "  " + this.exprSeq() + "\n";
				return this.exprSeq();
			}
			return "";
		}
		else if( this.type == "REQ" || this.type == "MASK" ){
			start = -1;
			for(i = 0; i < len; i++){
				if( v[i] == 1 ){
					start = i;
					break;
				}
			}
			if( start == -1 ){
				return "";
			}

			// REQ/MASK start check
			if( v[len + start] == 1 ){
				// NOT
				switch(src[start]){
				case 'T': case 't': case 'M': case '':
					return "";
				default:
					break;
				}
			}
			else{
				switch(src[start]){
				case 'F': case 'f': case 'M': case '':
					return "";
				default:
					break;
				}
			}

			// REQ/MASK end check
			for(i = 0; i < len; i++){
				if( v[2*len + i] != 1 ){
					continue;
				}

				if( this.type == "REQ" ){
					if( v[3*len + i] == 1 ){
						// NOT
						switch(src[i]){
						case 'T': case 't':
calcmsg += "  " + this.exprSeq() + " " + nodes[i].getText() + "=[T/t]\n";
							return this.exprSeq() + " " + nodes[i].getText() + "=[T/t]";
						default:
							break;
						}
					}
					else{
						switch(src[i]){
						case 'F': case 'f':
calcmsg += "  " + this.exprSeq() + " " + nodes[i].getText() + "=[F/f]\n";
							return this.exprSeq() + " " + nodes[i].getText() + "=[F/f]";
						default:
							break;
						}
					}
				}
				else if( this.type == "MASK" ){
					switch(src[i]){
					case 'M': case '':
						break;
					default:
calcmsg += "  " + this.exprSeq() + " " + nodes[i].getText() + "=[M]\n";
							return this.exprSeq() + " " + nodes[i].getText() + "=[M]";
					}
				}
				else{
					return "";
				}
			}

			return "";
		}
		else {
			return "";
		}
	}

	this.addSeqStart	= function(no, value, not)
	{
		var		len		= nodes.length;
		var		i		= 0;

		if( this.seq == "" ){
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += value + ",";
				}
				else{
					this.seq += "0,";
				}
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += not + ",";
				}
				else{
					this.seq += "0,";
				}
			}
			for(i = 0; i < len; i++){
				this.seq += "0,";
			}
			for(i = 0; i < len; i++){
				this.seq += "0,";
			}
		}
		else{
			var		r	= this.seq.split(",");

			this.seq = "";
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += value + ",";
				}
				else{
					this.seq += "0,";
				}
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += not + ",";
				}
				else{
					this.seq += "0,";
				}
			}
			for(i = 0; i < len; i++){
				this.seq += r[len*2 + i] + ",";
			}
			for(i = 0; i < len; i++){
				this.seq += r[len*3 + i] + ",";
			}
		}
		return true;
	}

	this.addSeqEnd		= function(no, value, not)
	{
		var		len		= nodes.length;
		var		i		= 0;

		if( this.seq == "" ){
			for(i = 0; i < len; i++){
				this.seq += "0,";
			}
			for(i = 0; i < len; i++){
				this.seq += "0,";
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += value + ",";
				}
				else{
					this.seq += "0,";
				}
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += not + ",";
				}
				else{
					this.seq += "0,";
				}
			}
		}
		else{
			var		r	= this.seq.split(",");

			this.seq = "";
			for(i = 0; i < len; i++){
				this.seq += r[i] + ",";
			}
			for(i = 0; i < len; i++){
				this.seq += r[len + i] + ",";
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += value + ",";
				}
				else{
					this.seq += r[len*2 + i] + ",";
				}
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += not + ",";
				}
				else{
					this.seq += r[len*3 + i] + ",";
				}
			}
		}
		return true;
	}

	this.drawLines			= function(no)
	{
		var		i		= 0;
		var		len		= nodes.length;
		var		r		= null;
		var		pos		= null;
		var		x1		= 0;
		var		x2		= 0;
		var		y1		= 0;
		var		y2		= 0;
		var		Xpoints	= new Array(3);
		var		Ypoints = new Array(3);
		var		degree	= 0;

		if( this.seq == "" ){
			return true;
		}

		r = this.seq.split(",");
		x2 = constrs[no].getLeft() + constrs[no].getWidth();
		y2 = constrs[no].getTop() + (constrs[no].getHeight())/2;
		for(i = 0; i < len; i++){
			if( r[i] != 1 ){
				continue;
			}

			// Start
			x1 = nodes[i].getLeft();
			y1 = nodes[i].getTop() + (nodes[i].getHeight())/2;
			degree	= Math.atan2(y2 - y1, x2 - x1);

			if( r[i + len] == 1 ){
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#ffa500";

				// 否定記号
				ctx.beginPath();
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.bezierCurveTo(
					(x1 + x2)/2 + nalen*Math.cos(degree - narc),
					(y1 + y2)/2 + nalen*Math.sin(degree - narc) - root_top,
					(x1 + x2)/2 + nalen*Math.cos(degree + narc),
					(y1 + y2)/2 + nalen*Math.sin(degree + narc) - root_top,
					(x1 + x2)/2 + nalen*Math.cos(degree + narc)
						+ nalen*Math.cos(degree - narc),
					(y1 + y2)/2 + nalen*Math.sin(degree + narc)
						+ nalen*Math.sin(degree - narc) - root_top);

				Xpoints[0] = (x1 + x2)/2;
				Xpoints[1] = (x1 + x2)/2 + alen*Math.cos(degree - arc);
				Xpoints[2] = (x1 + x2)/2 + alen*Math.cos(degree + arc);
				Ypoints[0] = (y1 + y2)/2;
				Ypoints[1] = (y1 + y2)/2 + alen*Math.sin(degree - arc);
				Ypoints[2] = (y1 + y2)/2 + alen*Math.sin(degree + arc);

				// 線分+矢尻
				ctx.moveTo(x1, y1 - root_top);
				ctx.lineTo(x2, y2 - root_top);
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.lineTo(Xpoints[1], Ypoints[1] - root_top);
				ctx.lineTo(Xpoints[2], Ypoints[2] - root_top);
				ctx.lineTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.stroke();
			}
			else{
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#000000";

				Xpoints[0] = (x1 + x2)/2;
				Xpoints[1] = (x1 + x2)/2 + alen*Math.cos(degree - arc);
				Xpoints[2] = (x1 + x2)/2 + alen*Math.cos(degree + arc);
				Ypoints[0] = (y1 + y2)/2;
				Ypoints[1] = (y1 + y2)/2 + alen*Math.sin(degree - arc);
				Ypoints[2] = (y1 + y2)/2 + alen*Math.sin(degree + arc);

				// 線分+矢尻
				ctx.beginPath();
				ctx.moveTo(x1, y1 - root_top);
				ctx.lineTo(x2, y2 - root_top);
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.lineTo(Xpoints[1], Ypoints[1] - root_top);
				ctx.lineTo(Xpoints[2], Ypoints[2] - root_top);
				ctx.lineTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.stroke();
			}

		}

		x1 = constrs[no].getLeft() + constrs[no].getWidth();
		y1 = constrs[no].getTop() + (constrs[no].getHeight())/2;
		for(i = 0; i < len; i++){
			if( r[len*2 + i] != 1 ){
				continue;
			}

			// End
			x2 = nodes[i].getLeft();
			y2 = nodes[i].getTop() + (nodes[i].getHeight())/2;
			degree	= Math.atan2(y2 - y1, x2 - x1);

			if( r[len*3 + i] == 1 ){
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#ffa500";

				// 否定記号
				ctx.beginPath();
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.bezierCurveTo(
					(x1 + x2)/2 + nalen*Math.cos(degree - narc),
					(y1 + y2)/2 + nalen*Math.sin(degree - narc) - root_top,
					(x1 + x2)/2 + nalen*Math.cos(degree + narc),
					(y1 + y2)/2 + nalen*Math.sin(degree + narc) - root_top,
					(x1 + x2)/2 + nalen*Math.cos(degree + narc)
						+ nalen*Math.cos(degree - narc),
					(y1 + y2)/2 + nalen*Math.sin(degree + narc)
						+ nalen*Math.sin(degree - narc) - root_top);

				// 線分+矢尻
				Xpoints[0] = (x1 + x2)/2;
				Xpoints[1] = (x1 + x2)/2 + alen*Math.cos(degree - arc);
				Xpoints[2] = (x1 + x2)/2 + alen*Math.cos(degree + arc);
				Ypoints[0] = (y1 + y2)/2;
				Ypoints[1] = (y1 + y2)/2 + alen*Math.sin(degree - arc);
				Ypoints[2] = (y1 + y2)/2 + alen*Math.sin(degree + arc);

				ctx.moveTo(x1, y1 - root_top);
				ctx.lineTo(x2, y2 - root_top);
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.lineTo(Xpoints[1], Ypoints[1] - root_top);
				ctx.lineTo(Xpoints[2], Ypoints[2] - root_top);
				ctx.lineTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.stroke();
			}
			else{
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#000000";

				// 線分+矢尻
				Xpoints[0] = (x1 + x2)/2;
				Xpoints[1] = (x1 + x2)/2 + alen*Math.cos(degree - arc);
				Xpoints[2] = (x1 + x2)/2 + alen*Math.cos(degree + arc);
				Ypoints[0] = (y1 + y2)/2;
				Ypoints[1] = (y1 + y2)/2 + alen*Math.sin(degree - arc);
				Ypoints[2] = (y1 + y2)/2 + alen*Math.sin(degree + arc);

				ctx.beginPath();
				ctx.moveTo(x1, y1 - root_top);
				ctx.lineTo(x2, y2 - root_top);
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.lineTo(Xpoints[1], Ypoints[1] - root_top);
				ctx.lineTo(Xpoints[2], Ypoints[2] - root_top);
				ctx.lineTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.stroke();
			}
		}
		return true;
	}

	this.drawText		= function(top, left)
	{
		var		x	= this.left - left;
		var		y	= this.top - top;

		// ノードの背景色
		ctx.fillStyle = "#ffffff";
		ctx.fillRect(x, y, this.width, this.height)

		// ノードの枠
		ctx.fillStyle = "#000000";
		ctx.lineWidth	= 1;
		ctx.beginPath();
		ctx.moveTo(x, y);
		ctx.lineTo(x + this.width, y);
		ctx.lineTo(x + this.width, y + this.height);
		ctx.lineTo(x, y + this.height);
		ctx.closePath();
		ctx.stroke();

		// 制約タイプ
		ctx.fillText(" " + this.type, this.left - left, this.top - top + 15);

		return true;
	}
}
