//////////////////////////////////////////////////////////////////////
// util.js
//  CHANGELOG
//  2010.05.08 checkStrong() 弱テスト条件の削除判定に関する不具合修正
//////////////////////////////////////////////////////////////////////

/** util.js */

function hideSUBS()
{
	hideELEMENT("EXPORTS");
	hideELEMENT("IMPORTS_CSV");
	hideELEMENT("IMPORTS_XCEG");
	hideELEMENT("CONFIGS");
	hideELEMENT("OPERATIONS");
	hideELEMENT("CALCS");
	hideELEMENT("CHANGELOG");
	hideELEMENT("MANUALS");
	hideELEMENT("QUERY");
	hideELEMENT("LINE_LEFT");
	hideELEMENT("LINE_RIGHT");
	hideELEMENT("LOGIC_STRING");
	hideELEMENT("TEXT_NODE");
	hideELEMENT("INPUT_NODE_LIST");
	hideELEMENT("INPUT_OP_LIST");
	hideELEMENT("INPUT_CONSTR_LIST");
	hideELEMENT("MESSAGE");
	hideELEMENT("CLEAR_CONFIRM");
	clearLINE();
}

function clearALL2(confirm)
{
	// グラフデータのクリア前に確認ダイアログを表示
	g_confirm_before_clear = !($("#NO_CONFIRM_BEFORE_CLEAR").attr("checked"));
	g_ceg_title	= "";

	clearALL();
	return true;
}

function clearALL()
{
	var		i;

	nodes	= new Array();
	// 2010/07/19 置換オブジェクトの初期化
	subs	= new Array();
	constrs	= new Array();
	logics	= new Array();
	tests	= new Array();
	covs	= new Array();
	dbg		= "";
	expdata	= "";
	exptable	= "";
	expcoverage	= "";
	g_zoom	= -1;

	ismove = false;

	for(i = 0; i < 100; i++){
		$("#N" + i).hide();
	}

	for(i = 0; i < 100; i++){
		$("#C" + i).hide();
	}

	hideSUBS();
	clearGRAPH();
	dispGRAPH();
	dispOUTPUTS();

// 2010/07/27 SessionStorageの削除
	expireINPUTS();

	logmsg += "CLEAR\n";
	dispMESSAGE("クリアしました", "#f8e58c");
	return true;
}

function clearMENU(idname)
{
	g_mmode = "";
	if( idname != "" ){
		$("#" + idname).attr("src", "images/" + idname + ".png");
	}
	$(".NODE,.CONSTR")
	.css("cursor", "move")
	.draggable("enable");

	hideSUBS();

	return true;
}

function downMENU(idname)
{
	// idnameのモードに変更
	g_mmode = idname;
	if( idname != "" ){
		$("#" + idname).attr("src", "images/" + idname + "down.png");
	}
	$(".NODE,.CONSTR")
	.draggable("disable");

	hideSUBS();

	return true;
}

function verticalPrint(src)
{
	var		j		= 0;
	var		txt		= "";
	var		ch		= "";

	for(j = 0; j < src.length; j++){
		ch = src.charAt(j);

		switch(ch){
		case '=': case '＝':
			txt += "<div>||</div>";
			break;
		case 'ー':	case '－':	case '-':
			txt += "<div>｜</div>";
			break;
		case '、':	case '。':
			txt += "<div class=\"punctuation\">" + src.charAt(j) + "</div>";
			break;
		case '「':
			txt += "<div class=\"left_bracket\">" + src.charAt(j) + "</div>";
			break;
		case '」':
			txt += "<div class=\"right_bracket\">" + src.charAt(j) + "</div>";
			break;
        case 'ぁ':
        case 'ぅ':
        case 'ぇ':
        case 'ぉ':
        case 'ゃ':
        case 'ゅ':
        case 'ょ':
        case 'っ':
        case 'ァ':
        case 'ゥ':
        case 'ェ':
        case 'ォ':
        case 'ャ':
        case 'ュ':
        case 'ョ':
        case 'ッ':
			txt += "<div class=\"small\">" + src.charAt(j) + "</div>";
			break;
		default:
			txt += "<div>" + src.charAt(j) + "</div>";
			break;
		}

	}

	return txt;
}

function TFM(src)
{
	if( src == "T" || src == "t" ){
		return "<td class=\"TRUE\">" + src + "</td>";
	}
	else if( src == "F" || src == "f" ){
		return "<td class=\"FALSE\">" + src + "</td>";
	}
	else if( src == "M" ){
		return "<td class=\"MASK\">" + src + "</td>";
	}
	else if( src == "I" ){
		return "<td class=\"IMPOSSIBLE\">" + src + "</td>";
	}
	else{
		return "<td>&nbsp;</td>";
	}
}

function TFMI(src, count)
{
	if( count == 0 ){
		return "<td class=\"INFEASIBLE\">" + src + "</td>";
	}
	else if( src == "T" || src == "t" ){
		return "<td class=\"TRUE\">" + src + "</td>";
	}
	else if( src == "F" || src == "f" ){
		return "<td class=\"FALSE\">" + src + "</td>";
	}
	else if( src == "M" ){
		return "<td class=\"MASK\">" + src + "</td>";
	}
	else{
		return "<td>&nbsp;</td>";
	}
}

// 2010/07/19 並べ替え関数
function posCompare(a, b)
{
	var		depth = nodes[b].getDepth() - nodes[a].getDepth();

//	if( depth == 0 ){
//		return( nodes[a].getTop() - nodes[b].getTop() );
//	}
//	else{
//		return depth;
//	}
	return( nodes[a].getTop() - nodes[b].getTop() );
}

function clearLINE()
{
	g_line_left = g_line_right = -1;
	g_line_constr = false;
	g_line_not = 0;
	$("#LINE_LEFT").css("color", "#000000").text("");
	$("#LINE_RIGHT").css("color", "#000000").text("");
	hideELEMENT("LINE_LEFT");
	hideELEMENT("LINE_RIGHT");
	return true;
}

// 汎用的なメッセージ表示
function dispMESSAGE(txt, bgcolor)
{
	if( g_mmode != "" || txt != "" ){
		if( txt == "" ){
			$("#MESSAGE")
			.css("background-color", bgcolor)
			.text(g_msgs[g_mmode])
			.slideDown("fast");
		}
		else{
			$("#MESSAGE")
			.css("background-color", bgcolor)
			.text(txt)
			.slideDown("fast");
		}
	}
	else{
		hideELEMENT("TEXT_NODE");
		hideELEMENT("INPUT_NODE_LIST");
	}
	return true;
}

// 汎用的な要素表示
function dispELEMENT(idname, top, left)
{
	$("#" + idname)
	.css("top", top + "px")
	.css("left", left + "px")
	.fadeIn();
	return true;
}

// 汎用的な要素非表示
function hideELEMENT(idname)
{
	$("#" + idname).hide();
	return true;
}

function dispTEXT_UPDATE(no, top, left)
{
	dispELEMENT("TEXT_UPDATE", top, left);

	// ノード番号
	$("#TEXT_UPDATE").attr("no", no);

	// ノード名
	$("#TEXT_NODE2")
	.val(nodes[no].getText())
	.focus();

	// 観測可能性
	if( nodes[no].getObs() == true ){
		$("#OBS_NODE").attr("checked", true);
	}
	else{
		$("#OBS_NODE").attr("checked", false);
	}

	// 判定順序
	if( nodes[no].getOrder() == true ){
		$("#ORDER_NODE").attr("checked", true);
	}
	else{
		$("#ORDER_NODE").attr("checked", false);
	}

	// メモ
	$("#MEMO_NODE")
	.val(nodes[no].getMemo());

	return true;
}

function dispOUTPUTS()
{
	calcEffect();
	calcConstraint();
	calcTABLE3(g_zoom);

	dispTABLE2(g_zoom);
	dispCOVERAGE2(g_zoom);

// 2010/07/27 SessionStorageを利用
	storeINPUTS();

	return true;
}

function dispTABLE()
{
	var		txt		= "";
	var		obs		= "";
	var		len		= nodes.length;
	var		clen	= 0;
	var		ilen	= 0;
	var		elen	= 0;
	var		i		= 0;
	var		j		= 0;
	var		testno	= 0;
	var		pos	= $("#TABLE").position();

	jQuery.each(nodes, function(i, val){
		if( this.getOp() == "" ){
			clen++;
		}
		else if( this.isEffect() == false ){
			ilen++;
		}
		else{
			elen++;
		}
	});

	if( len == 0 ){
		$("#TABLE")
		.html(txt)
		.hide();
		return true;
	}

	exptable = "";
	txt += "デシジョンテーブル<br />\n";
//	txt += "デシジョンテーブル　<span id=\"EDIT_DT\" title=\"デシジョンテーブルを編集する\">》編集</span><br />\n";
	txt += "<table class=\"DT\"><tr><th colspan=\"3\">ノード名</th>"
	exptable += ",,ノード名,";
	for(i = 0, testno = 0; i < tests.length; i++){
		if( weaks[i] == 1 ){
			continue;
		}
		txt += "<th>#" + (testno + 1) + "</th>";
		exptable += "#" + (testno + 1) + ",";
		testno++;
	}
	txt + "</tr>\n";
	exptable += "\n";
	if( clen > 0 ){
		j = 0;
// 2010/07/19 置換を元にして繰り返し処理
		for(i = 0; i < nodes.length; i++){
			var		obj	= nodes[subs[i]];
			if( obj.getOp() == "" ){
				obs = "&nbsp;";

				if( j == 0 ){
					txt += "<tr><td rowspan=\"" + (clen) + "\">原因:</td>"
						+ "<td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>"
				}
				else{
					txt += "<tr><td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>";
				}
				exptable += "原因,," + obj.getText() + ",";
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					txt += TFM(tests[k][subs[i]]);
					exptable += tests[k][subs[i]] + ",";
				}
				txt += "</tr>\n";
				exptable += "\n";
				j++;
			}
		}
	}
	if( ilen > 0 ){
		j = 0;
// 2010/07/19 置換を元にして繰り返し処理
		for(i = 0; i < nodes.length; i++){
			var		obj	= nodes[subs[i]];
			if( obj.getOp() != "" && obj.isEffect() == false ){
				if( obj.getObs() == true ){
					obs = "{obs}";
				}
				else{
					obs = "&nbsp;";
				}

				if( j == 0 ){
					txt += "<tr><td rowspan=\"" + (ilen) + "\">中間:</td>"
						+ "<td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>"
				}
				else{
					txt += "<tr><td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>";
				}
				exptable += "中間,," + obj.getText() + ",";
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					txt += TFM(tests[k][subs[i]]);
					exptable += tests[k][subs[i]] + ",";
				}
				txt += "</tr>\n";
				exptable += "\n";
				j++;
			}
		}
	}
	if( elen > 0 ){
		j = 0;
// 2010/07/19 置換を元にして繰り返し処理
		for(i = 0; i < nodes.length; i++){
			var		obj	= nodes[subs[i]];
			if( obj.getOp() != "" && obj.isEffect() == true ){
				obs = "{obs}";

				if( j == 0 ){
					txt += "<tr><td rowspan=\"" + (elen) + "\">結果:</td>"
						+ "<td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>"
				}
				else{
					txt += "<tr><td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>";
				}
				exptable += "結果,," + obj.getText() + ",";
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					txt += TFM(tests[k][subs[i]]);
					exptable += tests[k][subs[i]] + ",";
				}
				txt += "</tr>\n";
				exptable += "\n";
				j++;
			}
		}
	}
	txt += "</table><br />\n";
	exptable += "\n";

	$("#TABLE").html(txt);
	if( g_table_visible == true ){
		if( ismove == true ){
			dispELEMENT("TABLE", pos.top, pos.left);
		}
		else{
			dispELEMENT("TABLE",
				110, ($("#INPUTS").width() - $("#TABLE").width() - 50));
		}
	}
	return true;
}

// 2010/08/21 ズームアウト対応
function dispTABLE2(zoom)
{
	var		txt		= "";
	var		obs		= "";
	var		len		= nodes.length;
	var		clen	= 0;
	var		ilen	= 0;
	var		elen	= 0;
	var		i		= 0;
	var		j		= 0;
	var		testno	= 0;
	var		pos	= $("#TABLE").position();

	jQuery.each(nodes, function(i, val){
		var		ntype	= this.getNodeType(zoom, i);

		switch(ntype){
		case 0: // 原因
			clen++;
			break;
		case 1: // 中間
			ilen++;
			break;
		case 2: // 結果
			elen++;
			break;
		default: // 無視
			break;
		}
	});

	if( len == 0 ){
		$("#TABLE")
		.html(txt)
		.hide();
		return true;
	}

	exptable = "";
	if( zoom == -1 ){
		txt += "デシジョンテーブル<br />\n";
		// 2010/08/22 カプセル化されたノード名
		jQuery.each(nodes, function(i, val){
			if( this.getZoom() == i && i != zoom ){
				txt += "<span class=\"ZOOM\" no=\"" + i + "\">" + this.getText() + " のズームアウト</span><br />\n";
			}
		});
	}
	else{
		txt += "デシジョンテーブル(<span class=\"ZOOM\">" + nodes[zoom].getText() + "</span>)<br />\n";
	}
	txt += "<table class=\"DT\"><tr><th colspan=\"3\">ノード名</th>"
	exptable += ",,ノード名,";
	for(i = 0, testno = 0; i < tests.length; i++){
		if( weaks[i] == 1 ){
			continue;
		}
		txt += "<th>#" + (testno + 1) + "</th>";
		exptable += "#" + (testno + 1) + ",";
		testno++;
	}
	txt + "</tr>\n";
	exptable += "\n";
	if( clen > 0 ){
		j = 0;
		for(i = 0; i < nodes.length; i++){
			var		obj	= nodes[subs[i]];
			var		ntype	= obj.getNodeType(zoom, subs[i]);

			if( ntype == 0 ){
				obs = "&nbsp;";

				if( j == 0 ){
					txt += "<tr><td rowspan=\"" + (clen) + "\">原因:</td>"
						+ "<td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>"
				}
				else{
					txt += "<tr><td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>";
				}
				exptable += "原因,," + obj.getText() + ",";
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					txt += TFM(tests[k][subs[i]]);
					exptable += tests[k][subs[i]] + ",";
				}
				txt += "</tr>\n";
				exptable += "\n";
				j++;
			}
		}
	}
	if( ilen > 0 ){
		j = 0;
// 2010/07/19 置換を元にして繰り返し処理
		for(i = 0; i < nodes.length; i++){
			var		obj	= nodes[subs[i]];
			var		ntype	= obj.getNodeType(zoom, subs[i]);

			if( ntype == 1 ){
				if( obj.getObs() == true ){
					obs = "{obs}";
				}
				else{
					obs = "&nbsp;";
				}

				if( j == 0 ){
					txt += "<tr><td rowspan=\"" + (ilen) + "\">中間:</td>"
						+ "<td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>"
				}
				else{
					txt += "<tr><td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>";
				}
				exptable += "中間,," + obj.getText() + ",";
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					txt += TFM(tests[k][subs[i]]);
					exptable += tests[k][subs[i]] + ",";
				}
				txt += "</tr>\n";
				exptable += "\n";
				j++;
			}
		}
	}
	if( elen > 0 ){
		j = 0;
// 2010/07/19 置換を元にして繰り返し処理
		for(i = 0; i < nodes.length; i++){
			var		obj	= nodes[subs[i]];
			var		ntype	= obj.getNodeType(zoom, subs[i]);

			if( ntype == 2 ){
				obs = "{obs}";

				if( j == 0 ){
					txt += "<tr><td rowspan=\"" + (elen) + "\">結果:</td>"
						+ "<td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>"
				}
				else{
					txt += "<tr><td>" + obs + "</td>"
						+ "<td>" + obj.getText() + "</td>";
				}
				exptable += "結果,," + obj.getText() + ",";
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					txt += TFM(tests[k][subs[i]]);
					exptable += tests[k][subs[i]] + ",";
				}
				txt += "</tr>\n";
				exptable += "\n";
				j++;
			}
		}
	}
	txt += "</table><br />\n";

//	// 2010/08/22 カプセル化されたノード名
//	jQuery.each(nodes, function(i, val){
//		if( this.getZoom() == i && i != zoom ){
//			txt += "<span class=\"ZOOM\" no=\"" + i + "\">" + this.getText() + " をズームイン</span><br />\n";
//		}
//	});

	exptable += "\n";

	$("#TABLE").html(txt);
	if( g_table_visible == true ){
		if( ismove == true ){
			dispELEMENT("TABLE", pos.top, pos.left);
		}
		else{
			dispELEMENT("TABLE",
				110, ($("#INPUTS").width() - $("#TABLE").width() - 50));
		}
	}
	return true;
}

function dispCOVERAGE()
{
	var		txt		= "";
	var		tno		= "";
	var		i, j, k;
	var		testno	= 0;
	var		l		= 0;
	var		ccount	= 0;
	var		len		= nodes.length;
	var		clen	= 0;
	var		ilen	= 0;
	var		elen	= 0;
	var		pos	= $("#COVERAGE").position();

	if( len == 0 ){
		$("#COVERAGE").html(txt);
		hideELEMENT("COVERAGE");
		return true;
	}

	jQuery.each(nodes, function(i, val){
		if( this.getOp() == "" ){
			clen++;
		}
		else if( this.isEffect() == false ){
			ilen++;
		}
		else{
			elen++;
		}
	});

	expcoverage = "";
	txt += "カバレッジ表<br />\n";

	txt += "<table class=\"CV\"><tr><th>論理式</th>";
	expcoverage += "論理式,";
// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		if( obj.getOp() == "" ){
			txt += "<th>" + verticalPrint(obj.getText()) + "</th>";
			expcoverage += obj.getText() + ",";
		}
	}
// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		if( obj.getOp() != "" && obj.isEffect() == false ){
			txt += "<th>" + verticalPrint(obj.getText()) + "</th>";
			expcoverage += obj.getText() + ",";
		}
	}
// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		if( obj.getOp() != "" && obj.isEffect() == true ){
			txt += "<th>" + verticalPrint(obj.getText()) + "</th>";
			expcoverage += obj.getText() + ",";
		}
	}

	for(i = 0, testno = 0; i < tests.length; i++){
		if( weaks[i] == 1 ){
			continue;
		}
		tno = "＃" + (testno + 1);
		txt += "<th>" + verticalPrint(tno) + "</th>";
		expcoverage += "#" + (testno + 1) + ",";
		testno++;
	}
	txt += "<td>備考</td></tr>\n";
	expcoverage += "\n";

	l = 0;
// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
	for(i = 0; i < nodes.length; i++){
		var		obj		= nodes[i];
		var		lnum	= obj.getLnum();

		if( lnum > 1 ){
			for(j = 0; j < lnum; j++, l++){
				// 網羅状況の集計
				ccount = 0;
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					ccount += covs[k][l];
				}

				if( infeasibles[l] == "" ){
//				if( ccount > 0 ){
					txt += "<tr><td>論理式 "
						+ (l + 1) + "</td>";
					expcoverage += "論理式" + (l + 1) + ",";
				}
				else {
					txt += "<tr class=\"INFEASIBLE\"><td>論理式 "
						+ (l + 1) + "</td>";
					expcoverage += "//論理式" + (l + 1) + ",";
				}

// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
				for(k = 0; k < nodes.length; k++){
					var		obj2	= nodes[k];
					if( obj2.getOp() == "" ){
						txt += TFMI(obj.getLogicValue(i, j, k), ccount);
						expcoverage += obj.getLogicValue(i, j, k) + ",";
					}
				}
// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
				for(k = 0; k < nodes.length; k++){
					var		obj2	= nodes[k];
					if( obj2.getOp() != "" && obj2.isEffect() == false ){
						txt += TFMI(obj.getLogicValue(i, j, k), ccount);
						expcoverage += obj.getLogicValue(i, j, k) + ",";
					}
				}
// 2010/07/19 置換を元にして繰り返し処理
// 2010/07/24 一旦戻す
				for(k = 0; k < nodes.length; k++){
					var		obj2	= nodes[k];
					if( obj2.getOp() != "" && obj2.isEffect() == true ){
						txt += TFMI(obj.getLogicValue(i, j, k), ccount);
						expcoverage += obj.getLogicValue(i, j, k) + ",";
					}
				}

				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					if( covs[k][l] == 1 ){
						if( infeasibles[l] != "" ){
							txt += "<td class=\"INFEASIBLE\">&nbsp;</td>";
						}
						else if( ccount == 1 ){
							txt += "<td class=\"COVER\">#</td>";
							expcoverage += "#,";
						}
						else{
							txt += "<td class=\"COVER\">x</td>";
							expcoverage += "x,";
						}
					}
					else{
						if( infeasibles[l] != "" ){
							txt += "<td class=\"INFEASIBLE\">&nbsp;</td>";
						}
						else{
							txt += "<td class=\"COVER\">&nbsp;</td>";
						}
						expcoverage += ",";
					}
				}

				if( infeasibles[l] == "" ){
//				if( ccount > 0 ){
					txt += "<td>&nbsp;</td>";
				}
				else{
					txt += "<td>" + infeasibles[l] + "</td>";
				}

				txt += "</tr>";
				expcoverage += "\n";
			}
		}
	}

	txt += "</table><br />\n";
	expcoverage += "\n";

	$("#COVERAGE").html(txt);
	if( g_coverage_visible == true ){
		if( ismove == true ){
			dispELEMENT("COVERAGE", pos.top, pos.left);
		}
		else{
			dispELEMENT("COVERAGE",
				root_top + $("#TABLE").height() + 50,
				($("#INPUTS").width() - $("#COVERAGE").width() - 50));
		}
	}

	return true;
}

// 2010/08/21 ズームアウト対応
function dispCOVERAGE2(zoom)
{
	var		txt		= "";
	var		tno		= "";
	var		i, j, k;
	var		testno	= 0;
	var		l		= 0;
	var		ccount	= 0;
	var		len		= nodes.length;
	var		clen	= 0;
	var		ilen	= 0;
	var		elen	= 0;
	var		pos	= $("#COVERAGE").position();

	if( len == 0 ){
		$("#COVERAGE").html(txt);
		hideELEMENT("COVERAGE");
		return true;
	}

	jQuery.each(nodes, function(i, val){
		var		ntype	= this.getNodeType(zoom, i);

		switch(ntype){
		case 0: // 原因
			clen++;
			break;
		case 1:	// 中間
			ilen++;
			break;
		case 2: // 結果
			elen++;
			break;
		default: // 無視
			break;
		}
	});

	expcoverage = "";
	if( zoom == -1 ){
		// 通常にまたはズームアウト
		txt += "カバレッジ表<br />\n";
		// 2010/08/22 カプセル化されたノード名
		jQuery.each(nodes, function(i, val){
			if( this.getZoom() == i && i != zoom ){
				txt += "<span class=\"ZOOM\" no=\"" + i + "\">" + this.getText() + " のズームアウト</span><br />\n";
			}
		});
	}
	else{
		// ズームイン
		txt += "カバレッジ表(<span class=\"ZOOM\">" + nodes[zoom].getText() + "</span>)<br />\n";
	}

	txt += "<table class=\"CV\"><tr><th>論理式</th>";
	expcoverage += "論理式,";
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		var		ntype	= obj.getNodeType(zoom, i);

		switch(ntype){
		case 0: // 原因
		case 1: // 中間
		case 2: // 結果
			txt += "<th>" + verticalPrint(obj.getText()) + "</th>";
			expcoverage += obj.getText() + ",";
			break;
		default: // カプセル化
			break;
		}
	}

	for(i = 0, testno = 0; i < tests.length; i++){
		if( weaks[i] == 1 ){
			continue;
		}
		tno = "＃" + (testno + 1);
		txt += "<th>" + verticalPrint(tno) + "</th>";
		expcoverage += "#" + (testno + 1) + ",";
		testno++;
	}
	txt += "<td>備考</td></tr>\n";
	expcoverage += "\n";

	l = 0;
	for(i = 0; i < nodes.length; i++){
		var		obj		= nodes[i];
		var		lnum	= obj.getLnum();

		if( lnum > 1 ){
			for(j = 0; j < lnum; j++, l++){
				if( zoom == -1 ){
					// 通常時またはZOOM_OUT
					if( obj.getZoom() != -1 ){
						continue;
					}
				}
				else{
					// ZOOM_IN
					if( obj.getZoom() != zoom ){
						continue;
					}
				}

				// 網羅状況の集計
				ccount = 0;
				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}
					ccount += covs[k][l];
				}

				if( ccount > 0 ){
					txt += "<tr><td>論理式 "
						+ (l + 1) + "</td>";
					expcoverage += "論理式" + (l + 1) + ",";
				}
				else {
					txt += "<tr class=\"INFEASIBLE\"><td>論理式 "
						+ (l + 1) + "</td>";
					expcoverage += "//論理式" + (l + 1) + ",";
				}

				for(k = 0; k < len; k++){
					var		obj2	= nodes[k];
					var		ntype	= obj2.getNodeType(zoom, k);

					switch(ntype){
					case 0:
					case 1:
					case 2:
//						txt += TFMI(obj.getLogicValue(i, j, k), ccount);
//						expcoverage += obj.getLogicValue(i, j, k) + ",";
						txt += TFMI(logics[l][k], ccount);
						expcoverage += logics[l][k] + ",";
						break;
					default:
						break;
					}
				}

				for(k = 0; k < tests.length; k++){
					if( weaks[k] == 1 ){
						continue;
					}

					if( covs[k][l] == 1 ){
						if( ccount == 1 ){
							txt += "<td class=\"COVER\">#</td>";
							expcoverage += "#,";
						}
						else{
							txt += "<td class=\"COVER\">x</td>";
							expcoverage += "x,";
						}
					}
					else{
						if( ccount > 0 ){
							txt += "<td class=\"COVER\">&nbsp;</td>";
						}
						else{
							txt += "<td class=\"INFEASIBLE\">&nbsp;</td>";
						}
						expcoverage += ",";
					}
				}

				if( ccount > 0 ){
					txt += "<td>&nbsp;</td>";
				}
				else{
					txt += "<td>" + infeasibles[l] + "</td>";
				}

				txt += "</tr>";
				expcoverage += "\n";
			}
		}
	}

	txt += "</table><br />\n";
	expcoverage += "\n";

	$("#COVERAGE").html(txt);
	if( g_coverage_visible == true ){
		if( ismove == true ){
			dispELEMENT("COVERAGE", pos.top, pos.left);
		}
		else{
			dispELEMENT("COVERAGE",
				root_top + $("#TABLE").height() + 50,
				($("#INPUTS").width() - $("#COVERAGE").width() - 50));
		}
	}

	return true;
}

function storeINPUTS()
{
	var		ss	= window.sessionStorage;

	if( ss != undefined ){
		ss.setItem("input-data", getEXPORT_CSV_GRAPH());
	}

	return true;
}

function expireINPUTS()
{
	var		ss	= window.sessionStorage;

	if( ss != undefined ){
		ss.removeItem("input-data");
		ss.removeItem("history-data");
	}

	return true;
}

function getEXPORT_CSV_GRAPH()
{
	var		i,j,count;
	var		len	= nodes.length;

	expdata = "";

	// 実データ部
	expdata += nodes.length + "," + constrs.length + ",\n";
// 2010/07/19 置換を元にして繰り返し処理
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		expdata += obj.getText() + "\n"
	}
// 2010/07/19 置換を元にして繰り返し処理
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		expdata += obj.getTop() + ","
				+ obj.getLeft() + ","
				+ obj.getWidth() + ","
				+ obj.getHeight() + ","
				+ (obj.getObs() ? "obs" : "") + ","
				+ obj.getOp() + ","
				+ obj.getSeq() + ","
				+ obj.getZoom() + ","
				+ "\n";
	}
	jQuery.each(constrs, function(i, val){
		expdata += this.getType() + ","
				+ this.getTop() + ","
				+ this.getLeft() + ","
				+ this.getWidth() + ","
				+ this.getHeight() + ","
				+ this.getSeq() + ","
				+ this.getZoom() + ","
				+ "\n";
	});

	// コメント部
	expdata += "--\n"
	expdata += "[Cause Node]\n";
// 2010/07/19 置換を元にして繰り返し処理
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		if( obj.getOp() == "" ){
			expdata += obj.getText() + "=\n";
		}
	}
	expdata += "\n";

	expdata += "[Middle Node]\n";
// 2010/07/19 置換を元にして繰り返し処理
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		if( obj.getOp() != "" && obj.isEffect() == false ){
			expdata += obj.exprSeq() + ",\n";
		}
	}
	expdata += "\n";

	expdata += "[Result Node]\n";
// 2010/07/19 置換を元にして繰り返し処理
	for(i = 0; i < nodes.length; i++){
		var		obj	= nodes[i];
		if( obj.isEffect() == true ){
			expdata += obj.exprSeq() + ",\n";
		}
	}
	expdata += "\n";

	expdata += "[Constraint]\n";
	jQuery.each(constrs, function(i, val){
		expdata += this.exprSeq() + ",\n";
	});

	return expdata;
}

function getEXPORT_CSV_TABLE()
{
	var		i;

	return exptable;
}

function getEXPORT_CSV_COVERAGE()
{
	var		i;

	return expcoverage;
}

function getCONFIGS()
{
	// 原因結果グラフのタイトル
	$("#CEG_TITLE").val(g_ceg_title);

	// テーブル表示
	$("#CFG_TABLE_VISIBLE").attr("checked", g_table_visible);
	// カバレッジ表表示
	$("#CFG_COVERAGE_VISIBLE").attr("checked", g_coverage_visible);
	// ドラッグ中の描画同期
	$("#CFG_DRAGGING").attr("checked", g_dragging);
	// マウスオーバーによる関係式表示
	$("#CFG_HOVER_VISIBLE").attr("checked", g_hover_visible);
	// グラフデータのクリア前に確認ダイアログ表示
	$("#CFG_CONFIRM_BEFORE_CLEAR").attr("checked", g_confirm_before_clear);

	return true;
}

function setCONFIGS()
{
	// 原因結果グラフのタイトル
	g_ceg_title = $("#CEG_TITLE").val();

	// テーブル表示
	g_table_visible = $("#CFG_TABLE_VISIBLE").attr("checked");
	if( g_table_visible == false ){
		hideELEMENT("TABLE");
	}
	// カバレッジ表表示
	g_coverage_visible = $("#CFG_COVERAGE_VISIBLE").attr("checked");
	if( g_coverage_visible == false ){
		hideELEMENT("COVERAGE");
	}
	// ドラッグ中の描画同期
	g_dragging = $("#CFG_DRAGGING").attr("checked");

	// マウスオーバーによる関係式表示
	g_hover_visible = $("#CFG_HOVER_VISIBLE").attr("checked");

	// グラフデータのクリア前に確認ダイアログを表示
	g_confirm_before_clear = $("#CFG_CONFIRM_BEFORE_CLEAR").attr("checked");

	hideELEMENT("CONFIGS");

	dispMESSAGE("CEGTestの設定を変更しました", "#f8e58c");


	return true;
}

// ツールメニューの表示
function fadeInTOOLBAR(id, top, left)
{
	if( g_tmode != "" ){
		$("#" + g_tmode).hide();
	}

	g_tmode = id;
	if( id != "" ){
		$("#" + g_tmode)
		.css("top", top + "px")
		.css("left", left + "px")
		.fadeIn("fast");
	}
	return true;
}

function calcEffect()
{
	var		i		= 0;
	var		j		= 0;
	var		len		= nodes.length;
	var		r		= null;

	calcmsg = "";

	jQuery.each(nodes, function(i, val) {
		this.setEffect(true);
	});
	jQuery.each(nodes, function(i, val) {
		if( this.getSeq() != "" ){
			r = (this.getSeq()).split(',');

			for(j = 0; j < len; j++){
				if( r[j] == 1 ){
					nodes[j].setEffect(false);
				}
			}
		}
	});
	return true;
}

function calcConstraint()
{
	var		i, j, k, l;
	var		lnum	= 0;
	var		len	= nodes.length;
	var		ret	= true;
	var		txt	= "";
	var		v	= null;
	var		lcount	= 0;
	var		d	= 0;
	var		depth	= 0;

	l = 0;
	jQuery.each(nodes, function(i, val) {
		lnum = this.getLnum();
		for(j = 0; j < lnum; j++, l++){
			logics[l]	= new Array(len);
			infeasibles[l]	= "";

			for(k = 0; k < len; k++){
				logics[l][k]	= this.getLogicValue(i, j, k);
			}
calcmsg += "DEBUG: (1)logics[" + l + "][" + k + "]=" + logics[l] + "\n";

//			jQuery.each(constrs, function(k, val){
//				this.maskLogic(logics[l]);
//			});
//calcmsg += "DEBUG: (2)logics[" + l + "][" + k + "]=" + logics[l] + "\n";

//			infeasibles[l] = checkConstr(logics[l]);
//calcmsg += "infeasibles[" + l + "]=" + infeasibles[l] + "\n";
//calcmsg += "DEBUG: (3)logics[" + l + "][" + k + "]=" + logics[l] + "\n";
		}
	});

	return true;
}

function checkConstr(src)
{
	var		i	= 0;
	var		j	= 0;
	var		k	= 0;
	var		l	= 0;
	var		len	= nodes.length;
	var		cno	= -1;
	var		reason	= "";
	var		work	= new Array(len);

	for(i = 0; i < len; i++){
		work[i] = src[i];
	}

	jQuery.each(constrs, function(i, val) {
		this.maskLogic(work);
	});

	cno = -1;
	jQuery.each(constrs, function(i, val) {
		this.deduceLogic(work);
		reason = this.checkConstr(work);
		if( reason != "" ){
			cno = i;
			return;
		}
	});
	if( cno != -1 ){
		return constrs[cno].exprSeq();
	}

	for(i = 0; i < len; i++){
		src[i] = work[i];
	}
	return "";
}

function isPossible(src)
{
	var		i		= 0;
	var		len	= nodes.length;
	var		ret		= true;
	var		nno		= -1;
	var		work	= new Array(len);

	for(i = 0; i < len; i++){
		work[i] = src[i];
	}

	nno = -1;
	jQuery.each(nodes, function(i, val) {
		if( this.checkRelation(work, i) == false ){
			nno = i;
			return ret;
		}
	});
	if( nno != -1 ){
calcmsg += "## checkRelation() ERROR\n";
calcmsg += dispLOGIC(work);
calcmsg += "##### " + nodes[nno].exprSeq() + "\n\n";
		return nodes[nno].exprSeq();
	}

	return "";
}

function countCoverage(no)
{
	var		i	= 0;
	var		count	= 0;

	for(i = 0; i < covs.length; i++){
		count += covs[i][no];
	}
	return count;
}

// 「#」を含まないテスト条件のチェック
function checkStrong(no)
{
	var		i, j, k;
	var		strong	= 0;// 強条件
	var		weak	= 0;// 弱条件

	for(i = 0; i < covs[no].length; i++){
		var		ccount = 0;

		if( covs[no][i] == 0 ){
			continue;
		}

		for(j = 0; j < tests.length; j++){
			ccount += covs[j][i];
		}

		if( ccount == 1 ){
			strong++;
		}
		else if( ccount > 1 ){
			weak++;
		}
	}

	// 強条件がゼロの場合、そのテスト条件は削除
	if( strong == 0 && weak > 0 ){
		// 2010.05.08
		// このテスト条件を削除して問題ないか再確認
		for(i = 0; i < covs[no].length; i++){
			var		count	= 0;

			if( infeasibles[i] != "" ){
				continue;
			}

			for(j = 0; j < covs.length; j++){
				if( j == no ){
					continue;
				}
				if( weaks[j] == 1 ){
					continue;
				}
				count += covs[j][i];
			}
			if( count == 0 ){
				return true;
			}
		}

		return false;
	}
	else{
		return true;
	}
}

function calcTABLE()
{
	var		i, j;
	var		len		= nodes.length;
	var		vtest	= new Array(len);
	var		lnum	= 0;
	var		complete	= true;
	var		flag	= true;
	var		counts	= new Array(2);
	var		uncover	= -1;

	calcmsg = "";
	tests	= new Array();
	testnum = 0;
	covs	= new Array();

	lnum = 0;
	jQuery.each(nodes, function(i, val){
		lnum += this.getLnum();
	});

	// 論理点がゼロ
	if( lnum == 0 ){
		return true;
	}

	vtestcov	= new Array(lnum);
	unsuitables	= new Array(lnum + 2*len);
	testnum	= 0;

	// 最大でも lnum 回のテストで網羅できるはずなので
	for(i = 0; i < lnum; i++){
calcmsg += "-------------------------------------------------\n";
calcmsg += "[" + (i + 1) + "] 論理式選択\n";

		// vtest 初期化 */
		for(j = 0; j < len; j++){
			vtest[j] = "";
		}
		for(j = 0; j < lnum; j++){
			vtestcov[j] = 0;
		}
		for(j = 0; j < lnum + 2*len; j++){
			unsuitables[j] = 0;
		}

		turns = new Array();
		if( nextCondition(vtest, lnum) == true ){
			// 新しいテスト条件が見つかった
			tests[testnum] = new Array(len);
			for(j = 0; j < len; j++){
				tests[testnum][j] = vtest[j];
			}
			testnum++;
		}
calcmsg += "-------------------------------------------------\n";

		// 網羅完成か確認
		complete = true;
		for(j = 0; j < lnum; j++){
			if( infeasibles[j] != "" ){
				continue;
			}

			if( countCoverage(j) == 0 ){
				if( uncover == j ){
					dispMESSAGE("エラー: 論理式" + (uncover + 1) + "が網羅できませんでした", "#ff4500");
					return true;
				}
				uncover = j;
				complete = false;
				break;
			}
		}
		if( complete == true ){
			break;
		}

	}

	// 原因ノードのT/Fを網羅するための敗者復活
	jQuery.each(nodes, function(i, val) {
		if( this.getOp() == "" && this.getSeq() == ""
			&& this.isEffect() == false ){

			// 原因ノードの網羅数を count[x] に集計
			counts[0] = counts[1] = 0;
			for(j = 0; j < testnum; j++){
				if( tests[j][i] == "T" || tests[j][i] == "t" ){
					counts[0]++;
				}
				else if( tests[j][i] == "F" || tests[j][i] == "f" ){
					counts[1]++;
				}
			}

			for(j = 0; j < 2; j++){
				if( counts[j] > 0 ){
					continue;
				}

				for(k = 0; k < lnum; k++){
					vtestcov[k] = 0;
				}
				for(k = 0; k < lnum + 2*len; k++){
					unsuitables[k] = 0;
				}
				for(k = 0; k < len; k++){
					vtest[k] = "";
				}

				if( j == 0 ){
					vtest[i] = "t";
					turns = new Array();
					turns[turns.length] = lnum + i*2;
calcmsg += "-------------------------------------------------\n";
calcmsg += "##### 敗者復活 " + this.getText() + "=[t]\n";
				}
				else{
					vtest[i] = "f";
					turns = new Array();
					turns[turns.length] = lnum + i*2 + 1;
calcmsg += "-------------------------------------------------\n";
calcmsg += "##### 敗者復活 " + this.getText() + "=[f]\n";
				}

				// 1か所だけt/fを決定した状態でテスト条件を生成
				if( nextCondition(vtest, lnum) == true ){
					tests[testnum] = new Array(len);
					for(k = 0; k < vtest.length; k++){
						tests[testnum][k] = vtest[k];
					}
					testnum++;
				}
calcmsg += "-------------------------------------------------\n";

				// 敗者復活が他にあるかどうか
				complete = true;
				for(k = 0; k < lnum; k++){
					if( infeasibles[k] != "" ){
						continue;
					}

					if( countCoverage(k) == 0 ){
						complete = false;
						break;
					}
				}
			}
		}
	});

	// 弱テスト条件の確認
	weaks = new Array(tests.length);
	for(i = 0; i < weaks.length; i++){
		if( checkStrong(i) == true ){
			weaks[i] = 0;
		}
		else{
			weaks[i] = 1;
calcmsg += "##### 削除: 【#" + (i+1) + "】\n";
		}
	}

	return true;
}

// 2010/08/22 カプセル化その2
function calcTABLE3(zoom)
{
	var		i, j, k;
	var		len		= nodes.length;
	var		vtest	= new Array(len);
	var		lnum	= 0;
	var		complete	= true;
	var		flag	= true;
	var		counts	= new Array(2);
	var		uncover	= -1;
	var		zoomout	= false;

//	calcmsg = "";
	tests	= new Array();
	testnum = 0;
	covs	= new Array();

calcmsg += "DEBUG: g_zoom=" + g_zoom + "\n";
jQuery.each(nodes, function(i, val){
calcmsg += "DEBUG: " + i + " " + this.getZoom() + " " + this.getNodeType(zoom, i) + " " + this.getText() + "\n";
});

	jQuery.each(nodes, function(i, val){
		if( this.getZoom() != -1 ){
			zoomout = true;
		}
	});

	lnum = 0;
	jQuery.each(nodes, function(i, val){
		var		lnum2	= this.getLnum();

		if( zoom == -1 ){
			if( zoomout == true ){
				// ズームアウト
				for(j = 0; j < lnum2; j++){
					if( this.getZoom() != -1 ){
						infeasibles[lnum + j]
							= this.getText() + " のズームアウト";
					}
				}
			}
		}
		else{
			// ズームイン
			for(j = 0; j < lnum2; j++){
				if( this.getZoom() != zoom ){
					infeasibles[lnum + j]
						= this.getText() + " のズームイン";
				}
			}
		}

		lnum += lnum2;
	});

	// 論理点がゼロ
	// 2011/02/12 論理点がなくても制約があれば処理を継続する
	if( lnum == 0 && constrs.length == 0 ){
		return true;
	}

	vtestcov	= new Array(lnum);
	unsuitables	= new Array(lnum + 2*len);
	testnum	= 0;

	// 最大でも lnum 回のテストで網羅できるはずなので
	for(i = 0; i < lnum; i++){
calcmsg += "-------------------------------------------------\n";
calcmsg += "[" + (i + 1) + "] 論理式選択\n";

		// vtest 初期化 */
		for(j = 0; j < len; j++){
			vtest[j] = "";
		}
		for(j = 0; j < lnum; j++){
			vtestcov[j] = 0;
		}
		for(j = 0; j < lnum + 2*len; j++){
			unsuitables[j] = 0;
		}

		turns = new Array();
		if( nextCondition3(vtest, lnum, zoom) == true ){
			// 新しいテスト条件が見つかった
			tests[testnum] = new Array(len);
			for(j = 0; j < len; j++){
				tests[testnum][j] = vtest[j];
			}
			testnum++;
		}
calcmsg += "-------------------------------------------------\n";

		// 網羅完成か確認
		complete = true;
		for(j = 0; j < lnum; j++){
			if( infeasibles[j] != "" ){
				continue;
			}

			if( countCoverage(j) == 0 ){
				if( uncover == j ){
					dispMESSAGE("エラー: 論理式" + (uncover + 1) + "が網羅できませんでした", "#ff4500");
					return true;
				}
				uncover = j;
				complete = false;
				break;
			}
		}
		if( complete == true ){
			break;
		}

	}

	// 原因ノードのT/Fを網羅するための敗者復活
	jQuery.each(nodes, function(i, val) {
		var		ntype	= this.getNodeType(zoom, i);
		var		isolated	= true;
//		var		ordered		= false;

// 2011/02/12 孤立ノードかどうかの確認
		isolated = true;
		jQuery.each(nodes, function(j, val){
			var	seq	= this.getSeq();

			if( seq != "" ){
				var		r	= seq.split(",");

				if( r[i] == 1 ){
					isolated = false;
					return;
				}
			}
		});

// 2011/02/12 REQ制約の始点であるかどうかの確認
//		ordered = false;
//		jQuery.each(constrs, function(j, val){
//			var	type	= this.getType();
//			var	seq	= this.getSeq();
//
//			if( ( type == "REQ" || type == "MASK" ) && seq != "" ){
//				var		r	= seq.split(",");
//
//				if( r[i] == 1 ){
//					ordered = true;
//					return;
//				}
//			}
//		});

calcmsg += "DEBUG: 敗者復活 " + this.getText() + " " + i + " " + ntype + " " + isolated + " " + this.getSeq() + "\n";
		// 原因ノードかつ孤立ノードではない
// 2011/02/12 孤立ノードかどうかの確認
//		if( ntype == 0 && isolated == false ){
		if( ntype == 0 && isolated == false ){
//		if( ntype == 0 ){
			// 原因ノードの網羅数を count[x] に集計
			counts[0] = counts[1] = 0;
			for(j = 0; j < testnum; j++){
				if( tests[j][i] == "T" || tests[j][i] == "t" ){
					counts[0]++;
				}
				else if( tests[j][i] == "F" || tests[j][i] == "f" ){
					counts[1]++;
				}
			}

			for(j = 0; j < 2; j++){
				if( counts[j] > 0 ){
					continue;
				}

				for(k = 0; k < lnum; k++){
					vtestcov[k] = 0;
				}
				for(k = 0; k < lnum + 2*len; k++){
					unsuitables[k] = 0;
				}
				for(k = 0; k < len; k++){
					vtest[k] = "";
				}

				if( j == 0 ){
					vtest[i] = "t";
					turns = new Array();
					turns[turns.length] = lnum + i*2;
calcmsg += "-------------------------------------------------\n";
calcmsg += "##### 敗者復活 " + this.getText() + "=[t]\n";
				}
				else{
					vtest[i] = "f";
					turns = new Array();
					turns[turns.length] = lnum + i*2 + 1;
calcmsg += "-------------------------------------------------\n";
calcmsg += "##### 敗者復活 " + this.getText() + "=[f]\n";
				}

				// 1か所だけt/fを決定した状態でテスト条件を生成
// 2011/02/12 nextCondition -> nextCondition3 に変更
//				if( nextCondition(vtest, lnum, zoom) == true ){
				if( nextCondition3(vtest, lnum, zoom) == true ){
					tests[testnum] = new Array(len);
					for(k = 0; k < vtest.length; k++){
						tests[testnum][k] = vtest[k];
					}
					testnum++;
				}

calcmsg += "-------------------------------------------------\n";

				// 敗者復活が他にあるかどうか
				complete = true;
				for(k = 0; k < lnum; k++){
					if( infeasibles[k] != "" ){
						continue;
					}

					if( countCoverage(k) == 0 ){
						complete = false;
						break;
					}
				}
			}
		}
	});

	// 弱テスト条件の確認
	// 2011/02/12 論理点がない場合は行わない
	if( lnum > 0 ){
		weaks = new Array(tests.length);
		for(i = 0; i < weaks.length; i++){
			if( checkStrong(i) == true ){
				weaks[i] = 0;
			}
			else{
				weaks[i] = 1;
calcmsg += "##### 削除: 【#" + (i+1) + "】\n";
			}
		}
	}

	return true;
}
